package com.rjconsultores.ventaboletos.web.gui.controladores.esquemaoperacional;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Intbox;

import com.rjconsultores.ventaboletos.entidad.ConexionExcepcion;
import com.rjconsultores.ventaboletos.entidad.Corrida;
import com.rjconsultores.ventaboletos.service.ConexionExcepcionService;
import com.rjconsultores.ventaboletos.service.CorridaService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderCorridaConexion;

@Controller("editarConexionExcepcionController")
@Scope("prototype")
public class EditarConexionExcepcionController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	private static Logger log = Logger.getLogger(EditarConexionExcepcionController.class);

	@Autowired
	private ConexionExcepcionService conexionExcepcionService;
	@Autowired
	private CorridaService corridaService;
	@Autowired
	private transient PagedListWrapper<Corrida> plwServico;
	private MyListbox servicoList;
	private MyListbox servicoListSelList;
	private Intbox txtCorridaId;

	private ConexionExcepcion conexionExcepcion;
	private Long conexionCtrlId;
	private MyListbox conexionExcepcionList;
	private List<Integer> corridaIdList;

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);

		servicoList.setItemRenderer(new RenderCorridaConexion());
		servicoListSelList.setItemRenderer(new RenderCorridaConexion());

		conexionExcepcion = (ConexionExcepcion) Executions.getCurrent().getArg().get("conexionExcepcion");
		conexionExcepcionList = (MyListbox) Executions.getCurrent().getArg().get("conexionExcepcionList");
		conexionCtrlId = (Long) Executions.getCurrent().getArg().get("conexionCtrlId");

		if (conexionExcepcion.getConexionExcepcionId() != null) {
			Corrida corrida = corridaService.buscarPorId(conexionExcepcion.getNumcorrida()).iterator().next();
			servicoListSelList.addItemNovo(corrida);
		}

		corridaIdList = new ArrayList<Integer>();
		for (ConexionExcepcion ce : (List<ConexionExcepcion>) conexionExcepcionList.getListData()) {
			corridaIdList.add(ce.getNumcorrida());
		}

	}

	public void onClick$btnSalvar(Event ev) throws Exception {

		Corrida corrida = (Corrida) new ArrayList(Arrays.asList(servicoListSelList.getData())).iterator().next();

		if (corridaIdList.contains(corrida.getId().getCorridaId())) {
			Messagebox.show(Labels.getLabel("editarConexionExcepcionController.msg.erro.corrida"),
					Labels.getLabel("editarConexionExcepcionController.window.title"),
					Messagebox.OK, Messagebox.INFORMATION);
		} else {
			corridaIdList.add(corrida.getId().getCorridaId());

			conexionExcepcion.setNumcorrida(corrida.getId().getCorridaId());
			conexionExcepcion.setConexionctrlId(conexionCtrlId);

			if (conexionExcepcion.getConexionExcepcionId() != null) {
				conexionExcepcionList.removeItem(conexionExcepcion);
				conexionExcepcionService.actualizacion(conexionExcepcion);
				conexionExcepcionList.updateItem(conexionExcepcion);
			} else {
				conexionExcepcionService.suscribir(conexionExcepcion);
				conexionExcepcionList.addItemNovo(conexionExcepcion);
			}

			closeWindow();
		}
	}

	public void onDoubleClick$servicoList(Event ev) {
		if (servicoListSelList.getSize() == 0) {
			Corrida corridaAux = (Corrida) servicoList.getSelected();
			servicoListSelList.addItemNovo(corridaAux);
		} else {
			try {
				Messagebox.show(Labels.getLabel("editarConexionExcepcionController.MSG.corridaRepete"),
						Labels.getLabel("editarConexionExcepcionController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
			} catch (InterruptedException e) {
				log.error(e.getMessage());
			}
		}
	}

	public void onClick$btnPesquisaServico(Event ev) {

		Integer corridaId = txtCorridaId.getValue();
		servicoList.setData(corridaService.verificarCorridaId(corridaId));

		if (servicoList.getData().length == 0) {
			try {
				Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
						Labels.getLabel("editarConexionExcepcionController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
			} catch (InterruptedException ex) {
				log.error(ex.getMessage());
			}
		}
	}

}
